#include "IcomDevice.h"
#include "IcomSerial.h"
extern const bool bThreePorts;

void IcomDevice::dump(void)
{
	if (bThreePorts) return;
	Serial3.print(F("0x"));
	Serial3.print(origID,HEX);
	if (mappedID != 0xff){
		Serial3.print(F(" mapped->0x"));
		Serial3.print(mappedID, HEX);
	}
	Serial3.print(F(" p"));
	Serial3.print(comm->devID);
	if (comm->flagRead(hasRadioOnPort))
		Serial3.write('*');
	if (bitRead(typeFlag,ICOMDEVTYPE_RADIOBIT))
		Serial3.write('r');
	if (bitRead(typeFlag,ICOMDEVTYPE_VFOSUB))
		Serial3.write('s');
	if (bitRead(typeFlag,ICOMDEVTYPE_BROADCASTBIT) )
		Serial3.write('b');
	if (typeFlag)
	{
		Serial3.print(F(" VFOmain"));
		main.dump(typeFlag);
		Serial3.print(F(" VFOsub"));
		sub.dump(typeFlag);
	}
	Serial3.println();
}

void VFOState::dump(const byte type)
{
	Serial3.print(F(" Freq "));
	Serial3.print(freq);
	if (mode != 0xff)
	{
		Serial3.print(F(" m="));
		Serial3.print(mode,DEC);
		if (bandwidth){
			Serial3.print(F(" bw="));
			Serial3.print(bandwidth, DEC);
		}
		if (dataMode != 0xff)
		{
			Serial3.print(F(" dm="));
			Serial3.print(dataMode, DEC);
		}
	}
}