#ifndef ARDUINO_SIMPLEQUEUE
#define ARDUINO_SIMPLEQUEUE


#include <Arduino.h>


template <class x, byte sizex> class SimpleQueue
{
public:
	SimpleQueue(void) :
	  inIndex(0),
		  outIndex(0)
	  {
	  }
	  ~SimpleQueue(void) {
	  }
	  inline bool isAvailable(void) const { 
		  return inIndex != outIndex; 
	  }
	  inline x get(void) {
		  x  ret = buffer[outIndex]; 
		  ++outIndex; 
		  if (outIndex >= sizex) outIndex = 0; 
		  return ret; 
	  }
	  inline void put( x ptr) { 
		  buffer[inIndex] = ptr;  
		  ++inIndex; 
		  if (inIndex >= sizex) inIndex = 0; 
	  }
	  inline boolean check(void) {
		  byte next = inIndex+1;
		  if (next == sizex)  next = 0;
		  return next != outIndex;
	  }
	  inline byte number(void) const {
		  if (inIndex >= outIndex) return (inIndex - outIndex);
		  else return (inIndex - outIndex + sizex);
	  }



private:
	byte inIndex;
	byte outIndex;
	x buffer[sizex];
};

#endif //  ARDUINO_SIMPLEQUEUE
